#pragma GCC optimize "O3"
#include<bits/stdc++.h>
using namespace std;
using LL=long long;
#define FOR(i,l,r) for(int i=(l);i<=(r);++i)
#define REP(i,n) FOR(i,0,(n)-1)
#define ssize(x) int(x.size())
#ifdef DEBUG
auto&operator<<(auto&o,pair<auto,auto>p){return o<<"("<<p.first<<", "<<p.second<<")";}
auto operator<<(auto&o,auto x)->decltype(x.end(),o){o<<"{";int i=0;for(auto e:x)o<<","+!i++<<e;return o<<"}";}
#define debug(x...) cerr<<"["#x"]: ",[](auto...$){((cerr<<$<<"; "),...)<<endl;}(x)
#else
#define debug(...) {}
#endif

using T = __int128;
using Frac = pair<LL, LL>;
bool fun(Frac a, Frac b) {
	return a.first * T(b.second) < a.second * T(b.first);
}
Frac operator+(Frac a, Frac b) {
	Frac c;
	c.first = a.first * b.second + b.first * a.second;
	c.second = a.second * b.second;
	LL d = gcd(c.first, c.second);
	c.first /= d;
	c.second /= d;
	return c;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);

	int n, k;
	cin >> n >> k;
	vector<LL> h(n);
	REP(i, n)
		cin >> h[i];
	pair<Frac, int> best = {{1e18, 1}, -1};
	FOR(x, 1, k - 1) {
		const LL y = k - x;
		Frac sum = {0, 1};
		for (auto val : h) {
			sum = sum + Frac{(val + x - 1) / x, y};
		}
		if (fun(sum, best.first)) {
			best = {sum, x};
		}
		debug(x, y, sum, best);
	}
	auto [_, x] = best;
	cout << x << ' ' << k - x << endl;
}
