#pragma GCC optimize "O3"
#include<bits/stdc++.h>
using namespace std;
using LL=long long;
#define FOR(i,l,r) for(int i=(l);i<=(r);++i)
#define REP(i,n) FOR(i,0,(n)-1)
#define ssize(x) int(x.size())
#ifdef DEBUG
auto&operator<<(auto&o,pair<auto,auto>p){return o<<"("<<p.first<<", "<<p.second<<")";}
auto operator<<(auto&o,auto x)->decltype(x.end(),o){o<<"{";int i=0;for(auto e:x)o<<","+!i++<<e;return o<<"}";}
#define debug(x...) cerr<<"["#x"]: ",[](auto...$){((cerr<<$<<"; "),...)<<endl;}(x)
#else
#define debug(...) {}
#endif

int main() {
	cin.tie(0)->sync_with_stdio(0);

	int t;
	cin >> t;
	REP(tt, t) {
		int n;
		cin >> n;
		set<pair<int, int>> forbidden;
		REP(i, n) {
			int x, y;
			cin >> x >> y;
			forbidden.emplace(x, y);
		}
		auto ok = [&](set<pair<int, int>> s) {
			for (auto x : s) {
				if (forbidden.contains(x))
					return false;
			}
			return true;
		};
		set<set<pair<int, int>>> seen;
		queue<pair<int, set<pair<int, int>>>> q;
		q.emplace(pair<int, set<pair<int, int>>>(0, {{0, 0}}));
		bool found = false;
		while (ssize(q)) {
			auto [d, s] = q.front();
			q.pop();
			if (seen.contains(s))
				continue;
			seen.emplace(s);
			debug(d, s);
			if (ok(s)) {
				found = true;
				cout << "YES\n";
				break;
			}
			if (d >= 17)
				break;
			for (auto p : s) {
				auto [x, y] = p;
				if (s.contains(pair(x + 1, y)))
					continue;
				if (s.contains(pair(x, y + 1)))
					continue;
				auto cp = s;
				cp.erase(p);
				cp.emplace(x + 1, y);
				cp.emplace(x, y + 1);
				q.emplace(d + 1, cp);
			}
		}
		if (not found)
			cout << "NO\n";
	}
}
