#pragma GCC optimize "O3"
#include<bits/stdc++.h>
using namespace std;
using LL=long long;
#define FOR(i,l,r) for(int i=(l);i<=(r);++i)
#define REP(i,n) FOR(i,0,(n)-1)
#define ssize(x) int(x.size())
#ifdef DEBUG
auto&operator<<(auto&o,pair<auto,auto>p){return o<<"("<<p.first<<", "<<p.second<<")";}
auto operator<<(auto&o,auto x)->decltype(x.end(),o){o<<"{";int i=0;for(auto e:x)o<<","+!i++<<e;return o<<"}";}
#define debug(x...) cerr<<"["#x"]: ",[](auto...$){((cerr<<$<<"; "),...)<<endl;}(x)
#else
#define debug(...) {}
#endif
mt19937 rng(random_device{}());
int rd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

int main() {
	cin.tie(0)->sync_with_stdio(0);

	int maxw, maxh;
	cin >> maxw >> maxh;
	while(true) {
		int w = rd(1, maxw);
		int h = rd(1, maxh);
		if(w * h == 1)
			(rd(0, 1) ? w : h) += 1;
		vector<vector<bool>> blocked(w, vector<bool>(h));
		int bl = rd(0, w * h - 2);
		while(bl --> 0) {
			blocked[rd(0, w - 1)][rd(0, h - 1)] = true;
		}

		vector<pair<int, int>> free;
		REP(x, w)
			REP(y, h)
				if(not blocked[x][y])
					free.emplace_back(x, y);

		int ameba_size = rd(2, w * h);
		vector<vector<vector<bool>>> amebas;
		REP(iter, 100) {
			vector<vector<bool>> comp(w, vector<bool>(h));
			vector<pair<int, int>> lst = {free[rd(0, ssize(free) - 1)]};
			comp[lst.front().first][lst.front().second] = true;

			int iter_inner = 0;
			while(++iter_inner < 100 and ssize(lst) < ameba_size) {
				auto [x, y] = lst[rd(0, ssize(lst) - 1)];
				int s = rd(0, 3);
				int xx = x + array<int, 4>{{0, 1, 0, -1}}[s];
				int yy = y + array<int, 4>{{1, 0, -1, 0}}[s];
				if(0 <= min(xx, yy) and xx < w and yy < h and not blocked[xx][yy] and not comp[xx][yy]) {
					comp[xx][yy] = true;
					lst.emplace_back(xx, yy);
				}
			}

			if(ssize(lst) == ameba_size)
				amebas.emplace_back(comp);
		}

		if(ssize(amebas) >= 2) {
			cout << h << ' ' << w << '\n';
			REP(iter, 2) {
				REP(y, h) {
					REP(x, w)
						if(blocked[x][y])
							cout << 'X';
						else if(amebas[iter][x][y])
							cout << '*';
						else
							cout << '.';
					cout << '\n';
				}
				cout << '\n';
			}
			break;
		}
	}
}
