#pragma GCC optimize "O3"
#include<bits/stdc++.h>
using namespace std;
using LL=long long;
#define FOR(i,l,r) for(int i=(l);i<=(r);++i)
#define REP(i,n) FOR(i,0,(n)-1)
#define ssize(x) int(x.size())
#ifdef DEBUG
auto&operator<<(auto&o,pair<auto,auto>p){return o<<"("<<p.first<<", "<<p.second<<")";}
auto operator<<(auto&o,auto x)->decltype(x.end(),o){o<<"{";int i=0;for(auto e:x)o<<","+!i++<<e;return o<<"}";}
#define debug(x...) cerr<<"["#x"]: ",[](auto...$){((cerr<<$<<"; "),...)<<endl;}(x)
#else
#define debug(...) {}
#endif

int main() {
	cin.tie(0)->sync_with_stdio(0);

	int mt;
	cin >> mt;
	REP(tt, mt) {
		int n;
		cin >> n;
		vector left(3, 0);
		REP(i, 3)
			cin >> left[i];
		vector<int> v(n);
		REP(i, n)
			cin >> v[i];
		vector sum(3, 0ll);
		bool ans = false;
		function<void(int)> rec = [&](int pos) {
			if (pos == n) {
				LL total = sum[0] + sum[1] + sum[2];
				LL m = max({sum[0], sum[1], sum[2]});
				if (m < total - m) {
					ans = true;
				}
				return;
			}
			REP(i, 3) {
				if (left[i]) {
					--left[i];
					sum[i] += v[pos];
					rec(pos + 1);
					if (ans)
						return;
					++left[i];
					sum[i] -= v[pos];
				}
			}
		};
		rec(0);
		if (ans)
			cout << "YES\n";
		else
			cout << "NO\n";
	}
}
