#pragma GCC optimize "O3"
#include<bits/stdc++.h>
using namespace std;
using LL=long long;
#define FOR(i,l,r) for(int i=(l);i<=(r);++i)
#define REP(i,n) FOR(i,0,(n)-1)
#define ssize(x) int(x.size())
#ifdef DEBUG
auto&operator<<(auto&o,pair<auto,auto>p){return o<<"("<<p.first<<", "<<p.second<<")";}
auto operator<<(auto&o,auto x)->decltype(x.end(),o){o<<"{";int i=0;for(auto e:x)o<<","+!i++<<e;return o<<"}";}
#define debug(x...) cerr<<"["#x"]: ",[](auto...$){((cerr<<$<<"; "),...)<<endl;}(x)
#else
#define debug(...) {}
#endif
mt19937 rng(random_device{}());
int rd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

int main() {
	cin.tie(0)->sync_with_stdio(0);

	int n;
	cin >> n;
	n = rd(2, n);
	cout << n << '\n';
	vector<string> out(n, string(n, '?'));
	REP(i, n)
		out[i][i] = '.';
	int decided = rd(0, n / 2);
	set<pair<int, int>> s;
	while(ssize(s) < decided) {
		int v = rd(0, n - 1);
		int u = rd(0, n - 1);
		if(v < u)
			s.emplace(v, u);
	}
	for(auto [v, u] : s) {
		char c = rd(0, 1) ? 'F' : 'S';
		out[v][u] = out[u][v] = c;
	}
	REP(i, n)
		cout << out[i] << '\n';
}
